//
// SDLAudio.cpp
// Copyright (c) Michael J Stokes, 2007.  All rights reserved.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#pragma once

#include "Audio.h"


class SDLAudio : public Audio
{
// Construction
public:
	SDLAudio();
	virtual ~SDLAudio();
	
// Operations
public:
	virtual bool		Initialize();
	virtual void		Terminate();
	virtual void		Lock();
	virtual void		Unlock();
	virtual void		Pause( bool pause );
	
// Implementation
protected:
	static void			OnMix( void *self, Uint8 *stream, int length );
	
// Data
protected:
	SDL_AudioSpec		_format;
	int*				_buffer;
};
