//
// Ego.h
// Copyright Michael J Stokes, 2008.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#pragma once


class Ego
{
// Construction
public:
	Ego();
	virtual ~Ego();
	
// Inlines
public:
	inline const vec3& GetPosition() const
	{
		return _position;
	}
	
	inline const vec3& GetDirection() const
	{
		return _direction;
	}
	
// Operations
public:
	virtual bool Load( XMLElement* root );
	virtual void SetPosition( const vec3& position );
	virtual void Update( const vec3& direction, UINT actions );
	virtual void PreRender();
	
// Data
protected:
	vec3		_position;
	vec3		_direction;
};
