//
// EnvironmentMesh.h
// Copyright Michael J Stokes, 2008.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#pragma once

class Mesh;


class EnvironmentMesh
{
// Construction
public:
	EnvironmentMesh();
	~EnvironmentMesh();
	
// Enumeration
public:
	enum MeshFlags
	{
		NONE		= 0,
		CLIP		= 1,
		RENDER		= 2,
		DEPTH		= 4
	};
	
// Inlines
public:
	inline const string& GetName() const
	{
		return _name;
	}
	
	inline MeshFlags GetFlags() const
	{
		return (MeshFlags)_flags;
	}
	
// Operations
public:
	bool			Load( XMLElement* xml );
	XMLElement*		Save();
	void			Render();
	
// Data
protected:
	string			_name;
	scalar			_scale;
	int				_flags;
protected:
	Mesh*			_mesh;
	void*			_physics;
};
