//
// FileSearch.h
// Copyright Michael J Stokes, 2008.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#pragma once


class FileSearch
{
// Construction
public:
	inline FileSearch( PCSTR folder )
	{
#ifdef _WIN32
		string search( folder );
		search += "/*.*";
		memset( &_data, 0, sizeof( _data ) );
		_handle = FindFirstFile( search.c_str(), &_data );
#else
#error implement_me
#endif
	}
	
	inline ~FileSearch()
	{
#ifdef _WIN32
		if ( INVALID_HANDLE_VALUE != _handle ) FindClose( _handle );
#endif
	}
	
// Methods
public:
	inline bool GetNext( string & name, bool* folder = NULL )
	{
#ifdef _WIN32
		while ( INVALID_HANDLE_VALUE != _handle )
		{
			name = _data.cFileName;
			if ( NULL != folder ) *folder = 0 != ( _data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY );
			
			if ( ! FindNextFile( _handle, &_data ) )
			{
				FindClose( _handle );
				_handle = INVALID_HANDLE_VALUE;
			}
			
			if ( '.' != name[ 0 ] ) return true;
		}
		
		return false;
#endif
	}
	
// Data
protected:
#ifdef _WIN32
	HANDLE			_handle;
	WIN32_FIND_DATA	_data;
#endif
};
