//
// Material.h
// Copyright Michael J Stokes, 2008.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#pragma once

#include "Renderer.h"


class Material : public Resource
{
// Construction
public:
	Material( PCSTR name );
	virtual ~Material();
	
// Operations
public:
	virtual bool	Load();
	virtual bool	Upload();
	virtual void	Erase();
	void			Begin();
	void			End();
	
// Data
protected:
	vec3			_ambient;
	scalar			_pad1;
	vec3			_diffuse;
	scalar			_alpha;
	vec3			_specular;
	scalar			_pad2;
	scalar			_opacity;
	scalar			_shininess;
	bool			_flat;
protected:
	BYTE*			_image;
	int				_width;
	int				_height;
	GLuint			_texture;
};
