//
// MeshCompiler.h
// Copyright Michael J Stokes, 2008.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#pragma once

#pragma once


class MeshCompiler
{
// Construction
private:
	MeshCompiler() {};
	~MeshCompiler() {};
	
// Operations
public:
	static UINT32	GetModifiedTime( PCSTR path );
	static bool		IsFileNewer( PCSTR newer, PCSTR older );
	static bool		CompileOBJ( PCSTR input, PCSTR output, scalar scale = 1, PCSTR materials = NULL );
	static bool		CompileSkeleton( PCSTR input, PCSTR output, vector<string> & bones );
	
// Triplet
protected:
	struct Triplet
	{
		UINT32 position, normal, uv;
	};
	
// Group
protected:
	struct Group
	{
		string name;
		UINT32 first, count;
	};
	
// Implementation
protected:
	bool			CompileOBJImpl( PCSTR input, PCSTR output, scalar scale, PCSTR materials );
	void			AddVertex( UINT32 ip, UINT32 in, UINT32 iu );
	
// Data
protected:
	vector<Triplet>	_vertices;
	vector<UINT32>	_map[ 256 ];
	vector<UINT32>	_indices;
};
