//
// SkeletonTranslator.h
// Copyright Michael J Stokes, 2008.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#pragma once

#pragma once


class SkeletonTranslator
{
// Construction
private:
	SkeletonTranslator( PCSTR name, scalar scale, PCSTR material ) { _name = name; _scale = scale; _material = material; }
	~SkeletonTranslator() {};
	
// Operations
public:
	static bool Translate( PCSTR input, scalar scale = 1, PCSTR material = "" );
	static bool SKM( PCSTR input );
	
// Implementation
protected:
	bool	DoSkeleton();
	bool	DoMesh();
	bool	DoAnimation( XMLElement* source );
	
// Data
protected:
	string			_name;
	scalar			_scale;
	string			_material;
	vector<string>	_bones;
	vector<UINT>	_map;
};
