//
// WinAudio.cpp
// Copyright Michael J Stokes, 2009.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#pragma once

#ifdef _WIN32

#include "Audio.h"

struct IDirectSound;
struct IDirectSoundBuffer;


class WinAudio : public Audio
{
// Construction
public:
	WinAudio();
	virtual ~WinAudio();
	
// Operations
public:
	virtual bool		Initialize();
	virtual void		Terminate();
	virtual void		Lock();
	virtual void		Unlock();
	virtual void		Pause( bool pause );
	
// Implementation
protected:
	static void			ThreadEntry( void* self );
	virtual void		OnThread();
	
// Data
protected:
	IDirectSound*		_ds;
	IDirectSoundBuffer*	_dsb;
protected:
	bool				_thread;
	HANDLE				_events[ 5 ];
	CRITICAL_SECTION	_section;
protected:
	bool				_start;
	int*				_buffer;
};

#endif
