//
// BMLFrame.h
// Copyright Michael J Stokes, 2009.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#pragma once


class BMLFrame : public wxFrame
{
// Construction
public:
	BMLFrame();
	virtual ~BMLFrame();
	
	DECLARE_ABSTRACT_CLASS( BMLFrame )
	
// Operations
public:
	static inline BMLFrame* GetInstance()
	{
		return _instance;
	}
	
	void AddXML( PCSTR actor, XMLElement* xml );
	
// Implementation
protected:
	void AddXML( XMLElement* element, int depth = 1 );
	void BuildActorList();
	
// Events
protected:
	DECLARE_EVENT_TABLE()
	void OnClose( wxCloseEvent& event );
	void OnActivate( wxActivateEvent& event );
	void OnCharHook( wxKeyEvent& event );
	void OnExecute( wxCommandEvent& event );
	void OnLast( wxCommandEvent& event );
	void OnTemplate( wxCommandEvent& event );
	
// Data
protected:
	static BMLFrame*	_instance;
protected:
	wxSplitterWindow*	_splitter;
	wxRichTextCtrl*		_view;
	wxPanel*			_panel;
	wxComboBox*			_actor;
	wxComboBox*			_template;
	wxRichTextCtrl*		_edit;
	string				_last;
protected:
	vector<string>		_templates;
};
