//
// ConsoleCtrl.h
// Copyright Michael J Stokes, 2009.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#pragma once


class ConsoleCtrl : public wxListCtrl
{
// Construction
public:
	ConsoleCtrl( wxWindow* parent );
	virtual ~ConsoleCtrl();
	
	DECLARE_ABSTRACT_CLASS( ConsoleCtrl )
	
// Stream
protected:
	class Stream : public std::basic_streambuf<char>
	{
	public:
		Stream( ConsoleCtrl* console, std::ostream& stream );
		~Stream();
		
	private:
		virtual int_type		overflow( int_type v );
		virtual std::streamsize	xsputn( const char* p, std::streamsize n );
		
	private:
		ConsoleCtrl*	_console;
		std::ostream&	_stream;
		std::streambuf*	_old;
		string			_string;
	};
	
	void Deliver( Stream* stream, const string& line );
	
// Events
public:
	DECLARE_EVENT_TABLE()
	void OnSize( wxSizeEvent& event );
	
// Data
protected:
	Stream* _cout;
	Stream* _cerr;
};

