//
// Editor.cpp
// Copyright Michael J Stokes, 2008.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "Common.h"
#include "Editor.h"
#include "Application.h"
#include "MainFrame.h"

#include "Res/Activation.xpm"
#include "Res/Guide.xpm"
#include "Res/Location.xpm"
#include "Res/Meshes.xpm"
#include "Res/Open.xpm"
#include "Res/Run.xpm"
#include "Res/Star.xpm"

IMPLEMENT_APP( VGSEditorApp )


////////////////////////////////////////////////////////////////////////////////
// VGSEditorApp construction

VGSEditorApp::VGSEditorApp()
{
}

////////////////////////////////////////////////////////////////////////////////
// VGSEditorApp destruction

VGSEditorApp::~VGSEditorApp()
{
}

////////////////////////////////////////////////////////////////////////////////
// VGSEditorApp initialize the application

bool VGSEditorApp::OnInit()
{
	SetVendorName( T("Stokes") );
	SetAppName( T("VGSEditor") );
	
	MainFrame* main = new MainFrame();
	main->Show( true );
	
	return true;
}
