//
// FeatureDialog.h
// Copyright Michael J Stokes, 2008.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#pragma once


class FeatureDialog : public wxDialog
{
// Construction
public:
	FeatureDialog( wxWindow* parent );
	virtual ~FeatureDialog();
	
	DECLARE_ABSTRACT_CLASS( FeatureDialog )
	
// Implementation
protected:
	static int wxCALLBACK ListCompare( long item1, long item2, long sortData );
	
// Events
protected:
	DECLARE_EVENT_TABLE()
	void OnNameChange( wxCommandEvent& event );
	void OnRadio( wxCommandEvent& event );
	void OnBrowse( wxCommandEvent& event );
	void OnListSelected( wxListEvent& event );
	void OnListActivated( wxListEvent& event );
	void OnAdd( wxCommandEvent& event );
	void OnEdit( wxCommandEvent& event );
	void OnDelete( wxCommandEvent& event );
	void OnOK( wxCommandEvent& event );
	
// Data
protected:
	wxTextCtrl*		_name;
	wxRadioButton*	_optSimple;
	wxRadioButton*	_optScript;
	wxStaticText*	_simplePath;
	wxButton*		_simpleButton;
	wxListCtrl*		_list;
	wxButton*		_add;
	wxButton*		_edit;
	wxButton*		_delete;
};
