//
// GLView.h
// Copyright Michael J Stokes, 2008.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#pragma once


class GLView : public wxGLCanvas
{
// Construction
public:
	GLView( wxWindow* parent );
	virtual ~GLView();
	
	DECLARE_ABSTRACT_CLASS( GLView )
	
// Events
protected:
	DECLARE_EVENT_TABLE()
	void OnIdle( wxIdleEvent& event );
	void OnSize( wxSizeEvent& event );
	void OnErase( wxEraseEvent& event );
	void OnPaint( wxPaintEvent& event );
	void OnMouseMove( wxMouseEvent& event );
	void OnLeftDown( wxMouseEvent& event );
	void OnLeftUp( wxMouseEvent& event );
	void OnRightDown( wxMouseEvent& event );
	void OnRightUp( wxMouseEvent& event );
	void OnDoubleClick( wxMouseEvent& event );
	void OnCaptureLost( wxMouseCaptureLostEvent& event );
	void OnKeyDown( wxKeyEvent& event );
	void OnUpdateOpen( wxUpdateUIEvent& event );
	void OnUpdateFeature( wxUpdateUIEvent& event );
	void OnFeatureNew( wxCommandEvent& event );
	void OnFeatureEdit( wxCommandEvent& event );
	void OnFeatureDelete( wxCommandEvent& event );
	void OnPointActivation( wxCommandEvent& event );
	void OnPointLocation( wxCommandEvent& event );
	void OnPointGuide( wxCommandEvent& event );
	void OnUpdatePointDelete( wxUpdateUIEvent& event );
	void OnPointDelete( wxCommandEvent& event );
	
// Data
protected:
	void*		_app;
	DWORD		_time;
protected:
	vec3		_position;
	vec3		_angles;
	quaternion	_orientation;
protected:
	wxPoint		_lastPoint;
	bool		_turning;
	bool		_moving;
	bool		_dragging;
	bool		_sizing;
	vec3		_query;
	vec3		_target;
};
