//
// MainFrame.h
// Copyright Michael J Stokes, 2009.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#pragma once

class Sidebar;
class GLView;
class ConsoleCtrl;


class MainFrame : public wxFrame
{
// Construction
public:
	MainFrame();
	virtual ~MainFrame();
	
	DECLARE_ABSTRACT_CLASS( MainFrame )
	
// Implementation
protected:
	bool ProcessEvent( wxEvent& event );
	
// Events
protected:
	DECLARE_EVENT_TABLE()
	void OnClose( wxCloseEvent& event );
	void OnExit( wxCommandEvent& event );
	void OnNew( wxCommandEvent& event );
	void OnOpen( wxCommandEvent& event );
	void OnUpdateOpen( wxUpdateUIEvent& event );
	void OnUpdateRun( wxUpdateUIEvent& event );
	void OnRun( wxCommandEvent& event );
	void OnMeshes( wxCommandEvent& event );
	void OnBMLConsole( wxCommandEvent& event );
	void OnUpdateSmartbody( wxUpdateUIEvent& event );
	void OnSmartbody( wxCommandEvent& event );
	
// Data
protected:
	wxSplitterWindow*	_horizontal;
	wxSplitterWindow*	_vertical;
	Sidebar*			_sidebar;
	GLView*				_view;
	ConsoleCtrl*		_console;
};
