//
// Sidebar.h
// Copyright Michael J Stokes, 2009.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#pragma once

class Feature;


class Sidebar : public wxPanel
{
// Construction
public:
	Sidebar( wxWindow* parent );
	virtual ~Sidebar();
	
	DECLARE_ABSTRACT_CLASS( Sidebar )
	
// Implementation
protected:
	void			Update( wxCommandEvent& event );
	void			UpdateNode( wxTreeItemId parent, Feature* feature, bool selected );
	void			UpdateChild( const wxTreeItemId& parent, Feature* feature, int type, int index, const wxString& name, bool selected );
	
// Events
protected:
	DECLARE_EVENT_TABLE()
	void OnSelect( wxTreeEvent& event );
	
// TID
protected:
	class TID : public wxTreeItemData
	{
	// Construction
	public:
		inline TID( Feature* feature, int type = -1, int index = -1 )
		{
			this->feature	= feature;
			this->type		= type;
			this->index		= index;
		}
		
	// Data
	public:
		Feature*	feature;
		int			type;
		int			index;
	};
	
// Data
protected:
	wxBoxSizer*		_sizer;
	wxImageList		_images;
	wxTreeCtrl*		_tree;
};
